<template>
    <Layout class="bg-dark">
        <q-header class="q-px-md">
            <div class="text-center flex justify-center items-center">
                <q-icon size="20px" name="radar"></q-icon>
                <span class="q-ma-none text-h6 text-bold"> RADAR - 00:00:{{ String(countdown).padStart(2, '0') }}</span>
            </div>
        </q-header>
        <q-page class="row justify-center">
            <q-card
                v-for="colab in colabs" :key="colab.user_id"
                class="col-12 col-md-2 q-ma-xs q-pa-sm flex justify-center items-center"
                :class="[ colab.active ? 'bg-teal-7' : 'bg-red-9']"
            >
                <q-avatar size="200px">
                    <q-img :src="colab.src_avatar" :style="{ borderRadius: '50%', height: '200px'}"></q-img>
                    <q-badge v-if="!colab.active" floating color="transparent">
                        <q-btn color="teal" round @click="alertWhatsapp(colab.phone)">
                            <q-img width="23px" :src="`${baseUrl}/img/whatsapp_icon.svg`"></q-img>
                        </q-btn>
                    </q-badge>
                </q-avatar>
                <div class="bg-blue-grey-9 text-white absolute-bottom text-subtitle2 text-center">
                    <p class="q-ma-none text-bold">{{ colab.display_name ? colab.display_name : colab.email }}</p>
                    <p class="q-ma-none">{{ colab.task }}</p>
                </div>
            </q-card>
        </q-page>
    </Layout>
</template>
<script setup>
import {onMounted, ref} from 'vue'
import Layout from '../layouts/MainLayout.vue'
import { useQuasar } from "quasar";
import { api } from '../httpclient/api'
import axios from 'axios'
import {confirmeAlertMessageDialog} from "../components";

const $q = useQuasar()
const countdown = ref(59)
const colabs = ref([])
const baseUrl = import.meta.env.VITE_APP_URL

setInterval(() => {
    countdown.value -= 1;
    if(countdown.value === 0) {
        retrieveStatusTimer()
        countdown.value = 59
    }
}, 1000)
function retrieveUsers () {
    api.get('/users?format=json', {
        transformResponse: api.defaults.transformResponse.concat(function (data, headers) {
            Object.keys(data).forEach(function (index) {
                const details = getUserDetails(data[index].email)
                data[index].active = false
                data[index].task = 'DESCANSANDO'
                data[index].src_avatar = details.avatar
                data[index].phone = details.phone ? details.phone : null
            });
            return data;
        })
    })
    .then((response) => { colabs.value = response.data; retrieveStatusTimer() })
}
function retrieveStatusTimer () {
    api.get('/timer_running?format=json')
    .then((response) => {
        colabs.value.forEach((colab) => {
            const found = response.data.filter(task => task.user_id === colab.user_id)
            if (found.length > 0) {
                colab.active = true
                colab.task = found[0].name
            } else {
                colab.active = false
                colab.task = 'DESCANSANDO'
            }
        })
    })
}
function getUserDetails(email) {
    const avatars = [
        { email: 'gustavo.ghcmelo@gmail.com', avatar: `${baseUrl}/avatar/gustavo_melo.png`, phone: '5581996524390' },
        { email: 'artu.bsi@gmail.com', avatar: `${baseUrl}/avatar/arturlanez.png`, phone: '5581981546565' },
        { email: 'brunodossantosguerra@gmail.com', avatar: `${baseUrl}/avatar/bruno_guerra.png`, phone: '5581996090492' },
        { email: 'carlos.alexandre@fsbrcorp.com.br', avatar: `${baseUrl}/avatar/carlos_alexandre.png`, phone: '5581988656027' },
        { email: 'esmyrna.oliveira@gmail.com', avatar: `${baseUrl}/avatar/esmyrna.png`, phone: '5581993925428' },
        { email: 'hugosantos354@gmail.com', avatar: `${baseUrl}/avatar/hugo_santos.png`, phone: '5581997069559' },
        { email: 'jose.ewerton@fsbrcorp.com.br', avatar: `${baseUrl}/avatar/ewerton_costa.png`, phone: '5581996965136' },
        { email: 'luizparocha@gmail.com', avatar: `${baseUrl}/avatar/luiz_parocha.png`, phone: '5581999713310' },
        { email: 'mylena.amorim@fsbrcorp.com.br', avatar: `${baseUrl}/avatar/mylena_amorim.png`, phone: '5581991623339' },
        { email: 'priscila.cunha@fsbr.com.br', avatar: `${baseUrl}/avatar/priscila_yaeko.png`, phone: '5511985624966' },
        { email: 'rodolfo.guerra@fsbr.com.br', avatar: `${baseUrl}/avatar/rodolfo_guerra.png`, phone: '5581999970428' },
        { email: 'wesleydrrr@gmail.com', avatar: `${baseUrl}/avatar/wesley_alves.png`, phone: '5589994610488' },
        { email: 'fsbr.empresas@gmail.com', avatar: `${baseUrl}/avatar/fsbr_logo.png`, phone: '556' },
        { email: 'bmb.lucas@gmail.com', avatar: `${baseUrl}/avatar/lucas_coelho.png`, phone: '5567991054859' },
        { email: 'ricardojcfj@gmail.com', avatar: `${baseUrl}/avatar/ricardo_junior.png`, phone: '5583981150202' },
    ]

    const user = avatars.filter(data => email === data.email)
    if (user.length > 0) {
        return user[0]
    } else {
        return 'https://emi9d8rzue7.exactdn.com/wp-content/uploads/2021/06/Luca-Profile-Avatars-3.png?strip=all&lossy=1&ssl=1'
    }
}

function alertWhatsapp (phone) {
    $q.dialog({
        component: confirmeAlertMessageDialog
    }).onOk(async () => {
        $q.loading.show({ message: 'Alertando o colaborador(a)...' })
        await sendAlertToWhatsapp(phone)
        $q.loading.hide()
    })
}
onMounted(() => {
    retrieveUsers();
})

async function sendAlertToWhatsapp (phone) {
    await axios.post('https://wpp-md-dentalprev.zapdeveloper.com.br/sendText', {
        number: phone,
        session: 'radar',
        text: 'Opa! Passando pra lembrar de registrar o ponto no TimeCamp. Simbora pra Cima!!!'
    }, {
        headers: {
            Accept: 'application/json',
            ContentType: 'application/json',
            sessionkey: 'F756BC51C800E321DEC690A2DC2'
        }
    }).then(response => {
        $q.notify({ message: 'Alerta enviado com sucesso', type: 'positive', icon: 'check_circle_outline'})
    }).catch(error => {
        $q.notify({ message: 'Ops! deu pau. Configure corretamente a conexão com o whatsapp.', type: 'warning', icon: 'error_outline', position: 'top'})
    })
}
</script>

<style lang="sass" scoped>
.card-avatar
    width: 100%
    max-width: 250px
</style>
